/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TokenCurrency struct for TokenCurrency
type TokenCurrency struct {
	// The asset path of the transferred currency.
	AssetPath string `json:"asset_path"`
	// The currency symbol.
	Symbol *string `json:"symbol,omitempty"`
	// The name of the currency.
	Name *string `json:"name,omitempty"`
	// The decimal places right to the comma.
	Decimals *int32 `json:"decimals,omitempty"`
	// The currency type.
	Type   string `json:"type"`
	Detail *Token `json:"detail,omitempty"`
}

// NewTokenCurrency instantiates a new TokenCurrency object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTokenCurrency(assetPath string, type_ string) *TokenCurrency {
	this := TokenCurrency{}
	this.AssetPath = assetPath
	this.Type = type_
	return &this
}

// NewTokenCurrencyWithDefaults instantiates a new TokenCurrency object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTokenCurrencyWithDefaults() *TokenCurrency {
	this := TokenCurrency{}
	var type_ string = "token"
	this.Type = type_
	return &this
}

// GetAssetPath returns the AssetPath field value
func (o *TokenCurrency) GetAssetPath() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AssetPath
}

// GetAssetPathOk returns a tuple with the AssetPath field value
// and a boolean to check if the value has been set.
func (o *TokenCurrency) GetAssetPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AssetPath, true
}

// SetAssetPath sets field value
func (o *TokenCurrency) SetAssetPath(v string) {
	o.AssetPath = v
}

// GetSymbol returns the Symbol field value if set, zero value otherwise.
func (o *TokenCurrency) GetSymbol() string {
	if o == nil || o.Symbol == nil {
		var ret string
		return ret
	}
	return *o.Symbol
}

// GetSymbolOk returns a tuple with the Symbol field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenCurrency) GetSymbolOk() (*string, bool) {
	if o == nil || o.Symbol == nil {
		return nil, false
	}
	return o.Symbol, true
}

// HasSymbol returns a boolean if a field has been set.
func (o *TokenCurrency) HasSymbol() bool {
	if o != nil && o.Symbol != nil {
		return true
	}

	return false
}

// SetSymbol gets a reference to the given string and assigns it to the Symbol field.
func (o *TokenCurrency) SetSymbol(v string) {
	o.Symbol = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *TokenCurrency) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenCurrency) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *TokenCurrency) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *TokenCurrency) SetName(v string) {
	o.Name = &v
}

// GetDecimals returns the Decimals field value if set, zero value otherwise.
func (o *TokenCurrency) GetDecimals() int32 {
	if o == nil || o.Decimals == nil {
		var ret int32
		return ret
	}
	return *o.Decimals
}

// GetDecimalsOk returns a tuple with the Decimals field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenCurrency) GetDecimalsOk() (*int32, bool) {
	if o == nil || o.Decimals == nil {
		return nil, false
	}
	return o.Decimals, true
}

// HasDecimals returns a boolean if a field has been set.
func (o *TokenCurrency) HasDecimals() bool {
	if o != nil && o.Decimals != nil {
		return true
	}

	return false
}

// SetDecimals gets a reference to the given int32 and assigns it to the Decimals field.
func (o *TokenCurrency) SetDecimals(v int32) {
	o.Decimals = &v
}

// GetType returns the Type field value
func (o *TokenCurrency) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *TokenCurrency) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *TokenCurrency) SetType(v string) {
	o.Type = v
}

// GetDetail returns the Detail field value if set, zero value otherwise.
func (o *TokenCurrency) GetDetail() Token {
	if o == nil || o.Detail == nil {
		var ret Token
		return ret
	}
	return *o.Detail
}

// GetDetailOk returns a tuple with the Detail field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenCurrency) GetDetailOk() (*Token, bool) {
	if o == nil || o.Detail == nil {
		return nil, false
	}
	return o.Detail, true
}

// HasDetail returns a boolean if a field has been set.
func (o *TokenCurrency) HasDetail() bool {
	if o != nil && o.Detail != nil {
		return true
	}

	return false
}

// SetDetail gets a reference to the given Token and assigns it to the Detail field.
func (o *TokenCurrency) SetDetail(v Token) {
	o.Detail = &v
}

func (o TokenCurrency) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["asset_path"] = o.AssetPath
	}
	if o.Symbol != nil {
		toSerialize["symbol"] = o.Symbol
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.Decimals != nil {
		toSerialize["decimals"] = o.Decimals
	}
	if true {
		toSerialize["type"] = o.Type
	}
	if o.Detail != nil {
		toSerialize["detail"] = o.Detail
	}
	return json.Marshal(toSerialize)
}

type NullableTokenCurrency struct {
	value *TokenCurrency
	isSet bool
}

func (v NullableTokenCurrency) Get() *TokenCurrency {
	return v.value
}

func (v *NullableTokenCurrency) Set(val *TokenCurrency) {
	v.value = val
	v.isSet = true
}

func (v NullableTokenCurrency) IsSet() bool {
	return v.isSet
}

func (v *NullableTokenCurrency) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTokenCurrency(val *TokenCurrency) *NullableTokenCurrency {
	return &NullableTokenCurrency{value: val, isSet: true}
}

func (v NullableTokenCurrency) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTokenCurrency) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
